#!/usr/bin/python
#---------------------------------------------------------------
# Project         : LADS
# Module          : lads
# File            : testutmp.py
# Version         : $Id: testutmp.py,v 1.1.1.1 2003/02/04 19:09:47 fred Exp $
# Author          : Frederic Lepied
# Created On      : Sun Feb  2 15:49:55 2003
#---------------------------------------------------------------

import utmp
import UTMPCONST

users={}

wtmp = utmp.UtmpRecord(UTMPCONST.WTMP_FILE)

entry = wtmp.getutent()

while entry:
    if entry[0] == UTMPCONST.USER_PROCESS:
        users[entry[2]] = entry
    elif entry[0] == UTMPCONST.DEAD_PROCESS:
        try:
            del users[entry[2]]
        except KeyError:
            pass
    entry = wtmp.getutent()

for u in users.values():
    print u
    
while 1:
    if not entry:
        entry = wtmp.getutent()
        continue
    if entry[0] == UTMPCONST.USER_PROCESS:
        users[entry[2]] = entry
        print "detected login of %s on %s from %-30s" % (entry[4], entry[2], entry[5])
    elif entry[0] == UTMPCONST.DEAD_PROCESS:
        try:
            u = users[entry[2]]
            print "detected logout of %s from %s" % (u[4], entry[2])
            del users[entry[2]]
        except KeyError:
            print 'unkown user log out from %s' % entry[2]
    entry = wtmp.getutent()
    
# testutmp.py ends here
